package com.bib.essensbestellungsverwaltung;

import javafx.fxml.FXML;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.Spinner;
import javafx.scene.input.MouseEvent;
import javafx.scene.text.Text;

import java.util.Calendar;

public class InvoiceController {
    @FXML
    Text responseText;
    @FXML
    ChoiceBox monatChoiceBox;

    @FXML
    Spinner jahrSpinner;

    @FXML
    public void initialize() {
        monatChoiceBox.setValue(intToMonth(Calendar.getInstance().get(Calendar.MONTH) + 1));
        jahrSpinner.getValueFactory().setValue(Calendar.getInstance().get(Calendar.YEAR));
    }

    @FXML
    void onRechnungErstellenClick(MouseEvent mouseEvent) {
        responseText.setText(monatChoiceBox.getValue().toString() + jahrSpinner.getValue());
        // hier rechnung erstellen
    }

    private int monthToInt(String month) {
        return switch (month) {
            case "Januar" -> 1;
            case "Februar" -> 2;
            case "März" -> 3;
            case "April" -> 4;
            case "Mai" -> 5;
            case "Juni" -> 6;
            case "Juli" -> 7;
            case "August" -> 8;
            case "September" -> 9;
            case "Oktober" -> 10;
            case "November" -> 11;
            case "Dezember" -> 12;
            default -> -1;
        };
    }

    private String intToMonth(int month) {
        return switch (month) {
            case 1 -> "Januar";
            case 2 -> "Februar";
            case 3 -> "März";
            case 4 -> "April";
            case 5 -> "Mai";
            case 6 -> "Juni";
            case 7 -> "Juli";
            case 8 -> "August";
            case 9 -> "September";
            case 10 -> "Oktober";
            case 11 -> "November";
            case 12 -> "Dezember";
            default -> "";
        };
    }
}
